<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    exclude-result-prefixes="xs"
    version="2.0">
    <xsl:output method="xml" indent="yes"/>

    <!-- this is the xpath query for mei2012: distinct-values(//xs:element[not(./xs:complexType/@mixed eq 'true')]/@name) -->

    <xsl:variable name="tags">
        <tag>accid</tag>
        <tag>address</tag>
        <tag>artic</tag>
        <tag>barLine</tag>
        <tag>body</tag>
        <tag>castList</tag>
        <tag>castGrp</tag>
        <tag>chord</tag>
        <tag>clef</tag>
        <tag>clefGrp</tag>
        <tag>custos</tag>
        <tag>dot</tag>
        <tag>ending</tag>
        <tag>expansion</tag>
        <tag>group</tag>
        <tag>grpSym</tag>
        <tag>incip</tag>
        <tag>instrGrp</tag>
        <tag>instrDef</tag>
        <tag>keyAccid</tag>
        <tag>keySig</tag>
        <tag>layer</tag>
        <tag>layerDef</tag>
        <tag>lb</tag>
        <tag>mdiv</tag>
        <tag>mei</tag>
        <tag>music</tag>
        <tag>note</tag>
        <tag>pad</tag>
        <tag>parts</tag>
        <tag>part</tag>
        <tag>pb</tag>
        <tag>phrase</tag>
        <tag>rest</tag>
        <tag>sb</tag>
        <tag>score</tag>
        <tag>scoreDef</tag>
        <tag>section</tag>
        <tag>space</tag>
        <tag>staff</tag>
        <tag>staffDef</tag>
        <tag>staffGrp</tag>
        <tag>titlePage</tag>
        <tag>meiHead</tag>
        <tag>appInfo</tag>
        <tag>application</tag>
        <tag>availability</tag>
        <tag>change</tag>
        <tag>changeDesc</tag>
        <tag>classification</tag>
        <tag>correction</tag>
        <tag>contents</tag>
        <tag>editionStmt</tag>
        <tag>editorialDecl</tag>
        <tag>encodingDesc</tag>
        <tag>ensemble</tag>
        <tag>fileDesc</tag>
        <tag>handList</tag>
        <tag>history</tag>
        <tag>incipText</tag>
        <tag>interpretation</tag>
        <tag>meter</tag>
        <tag>termList</tag>
        <tag>langUsage</tag>
        <tag>normalization</tag>
        <tag>notesStmt</tag>
        <tag>perfMedium</tag>
        <tag>performer</tag>
        <tag>physDesc</tag>
        <tag>projectDesc</tag>
        <tag>pubStmt</tag>
        <tag>relatedItem</tag>
        <tag>respStmt</tag>
        <tag>revisionDesc</tag>
        <tag>samplingDecl</tag>
        <tag>segmentation</tag>
        <tag>seriesStmt</tag>
        <tag>source</tag>
        <tag>sourceDesc</tag>
        <tag>stdVals</tag>
        <tag>titleStmt</tag>
        <tag>workDesc</tag>
        <tag>work</tag>
        <tag>eventList</tag>
        <tag>arpeg</tag>
        <tag>beam</tag>
        <tag>beamSpan</tag>
        <tag>beatRpt</tag>
        <tag>bend</tag>
        <tag>breath</tag>
        <tag>bTrem</tag>
        <tag>fermata</tag>
        <tag>fTrem</tag>
        <tag>hairpin</tag>
        <tag>harpPedal</tag>
        <tag>gliss</tag>
        <tag>halfmRpt</tag>
        <tag>measure</tag>
        <tag>mRest</tag>
        <tag>mRpt</tag>
        <tag>mRpt2</tag>
        <tag>mSpace</tag>
        <tag>multiRest</tag>
        <tag>multiRpt</tag>
        <tag>octave</tag>
        <tag>ossia</tag>
        <tag>pedal</tag>
        <tag>slur</tag>
        <tag>tie</tag>
        <tag>tuplet</tag>
        <tag>tupletSpan</tag>
        <tag>mensur</tag>
        <tag>proport</tag>
        <tag>ligature</tag>
        <tag>ineume</tag>
        <tag>syllable</tag>
        <tag>uneume</tag>
        <tag>mordent</tag>
        <tag>trill</tag>
        <tag>turn</tag>
        <tag>meiCorpus</tag>
        <tag>app</tag>
        <tag>lem</tag>
        <tag>rdg</tag>
        <tag>choice</tag>
        <tag>gap</tag>
        <tag>handShift</tag>
        <tag>subst</tag>
        <tag>facsimile</tag>
        <tag>surface</tag>
        <tag>zone</tag>
        <tag>graphic</tag>
        <tag>fig</tag>
        <tag>table</tag>
        <tag>tr</tag>
        <tag>barre</tag>
        <tag>chordDef</tag>
        <tag>chordMember</tag>
        <tag>chordTable</tag>
        <tag>fb</tag>
        <tag>timeline</tag>
        <tag>when</tag>
        <tag>lyrics</tag>
        <tag>verse</tag>
        <tag>cc</tag>
        <tag>chan</tag>
        <tag>chanPr</tag>
        <tag>midi</tag>
        <tag>noteOff</tag>
        <tag>noteOn</tag>
        <tag>port</tag>
        <tag>prog</tag>
        <tag>seqNum</tag>
        <tag>vel</tag>
        <tag>performance</tag>
        <tag>recording</tag>
        <tag>clip</tag>
        <tag>avFile</tag>
        <tag>ptr</tag>
        <tag>back</tag>
        <tag>quote</tag>
        <tag>div</tag>
        <tag>front</tag>
        <tag>lg</tag>
        <tag>list</tag>
        <tag>curve</tag>
        <tag>symbol</tag>
        <tag>symbolDef</tag>
        <tag>symbolTable</tag>
    </xsl:variable>
    
    
    <xsl:template match="/">
        <xsl:apply-templates/>
    </xsl:template>
    
    <xsl:template match="node()">
        <xsl:choose>
            <xsl:when test="some $name in $tags/tag/text() satisfies $name = local-name()">
                <xsl:copy>
                    <xsl:apply-templates select="* | comment() | processing-instruction() | @*"/>
                </xsl:copy>
            </xsl:when>
            <xsl:otherwise>
                <xsl:copy>
                    <xsl:apply-templates select="node() | @*"/>
                </xsl:copy>
            </xsl:otherwise>
        </xsl:choose>
        
    </xsl:template>
    
    <xsl:template match="@*">
        <xsl:copy/>
    </xsl:template>
        
</xsl:stylesheet>